//---------------------------------------------------------------------------

//#include <vcl.h>
#include <stdio.h>
#pragma hdrstop
#include "gpc.h"
#include "proto.h"
#include "init.h"
#include "magic.h"
#include "problem.h"
#include "getparams.h"
#include "globals.h"
#include "memwatch.h"

//---------------------------------------------------------------------------

#pragma argsused
int main(int argc, char* argv[])
{

  P.inputTrainDataFromFile("train.dat");
  P.inputTestDataFromFile("test.dat");
  P.normalize();

  Param.max_depth_for_new_trees[0] = 10;
  Param.population_size[0] = 60;
  Param.elite_size[0] = 10;
  Param.numgens = 20;

  Param.elite_dupe[0] = 1;
  Param.crossover_dupe[0] = 0;
  
  Param.crossover_func_pt_fraction[0]= 0.4;
  Param.crossover_any_pt_fraction[0] = 0.4;
  Param.fitness_prop_repro_fraction[0] = 0.0;
  
  Param.set_global_param();
  Param.set_local_param();

  Param.seed = 99;

  Param.func_gen_fraction[0] = 0.5;
  Param.terminal_table_size[0] = 200;

  init_globals();

  P.reg_param=0.005;

  fprintf(stderr,"%lf\n",P.data_train_variance);

  for (int i=0; i< P.numgens;i++)
    {
      run_one_generation(START_GEN, i, POP, GRID);
      Result.update_populations();
      fprintf(stderr,"%d) mse: %lf mld: %lf\n", 
	      i,Result.best_mse[0],Result.best_mdl[0]);
    }

  Result.update_populations();
  Result.set_best_value(0);
  Result.set_best_pred2(0);

  for (int i=0; i < P.data_max; i++)
    {
      printf("%d %lf %lf\n",i,P.data[i],Result.output2[i]);
    }

  free_globals();
  fprintf(stderr, "end\n");



  return 0;
}
//---------------------------------------------------------------------------
 
