/*
SGPC: Simple Genetic Programming in C
(c) 1993 by Walter Alden Tackett and Aviram Carmi

 This code and documentation is copyrighted and is not in the public domain.
 All rights reserved.

 - This notice may not be removed or altered.

 - You may not try to make money by distributing the package or by using the
   process that the code creates.

 - You may not distribute modified versions without clearly documenting your
   changes and notifying the principal author.

 - The origin of this software must not be misrepresented, either by
   explicit claim or by omission.  Since few users ever read sources,
   credits must appear in the documentation.

 - Altered versions must be plainly marked as such, and must not be
   misrepresented as being the original software.  Since few users ever read
   sources, credits must appear in the documentation.

 - The authors are not responsible for the consequences of use of this
   software, no matter how awful, even if they arise from flaws in it.

If you make changes to the code, or have suggestions for changes,
let us know!  (gpc@ipld01.hac.com)
*/

#ifndef lint
static char eval_c_rcsid[]="$Id: eval.cpp,v 1.2 2006/09/02 22:33:04 yanase Exp $";
#endif

/*
 *
 * $Log: eval.cpp,v $
 * Revision 1.2  2006/09/02 22:33:04  yanase
 * add rename_tree_hold_type() in treegen.cpp/proto.h
 * to maintain the function node type after crossover and mutation.
 * replaced rename_tree by rename_tree_hold_type().
 * see also crossover.cpp and mutation.cpp.
 *
 * Revision 1.1.1.1  2006/08/31 08:56:26  yanase
 * This is the implementation of Inductive GP written in Adaptive Learning of Polynomial Networks.
 *
 * Revision 1.1.1.1  2006/08/21 09:52:44  caranha
 * Uploaded strogonoff Unix 02/2006 version to the server
 *
 * Revision 1.1  2006/01/24 03:54:24  caranha
 * Added initial files - stroglib is the library, debug-app is a debug application for the library - should not be needed
 *
 * Revision 2.5  1993/04/29  20:39:23  gpc-avc
 * Added checks for NaN and infinity for results of eval
 *
 * Revision 2.4  1993/04/22  07:39:12  gpc-avc
 * Removed old log messages
 *
 * Revision 2.3  1993/04/14  05:03:32  gpc-avc
 * Just a change to revision number
 *
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#ifdef MACOSX
#include <limits.h>
#else
#include <values.h>
#endif
#include <float.h>
#include "gpc.h"
#include "proto.h"
#include "treeio.h"
#include "globals.h"

GENERIC eval(
  tree *t
  )
{
  GENERIC val;


  val = evaluate_tree(t);
  if (isnan(val)) val = (GENERIC)0.0;
  /*   if (isinf(val)) val = (GENERIC)MAXINT; */
  return(val);
}


GENERIC evaluate_tree(
  tree *t
  )
{
  int 	i;
  double ans;

  fast_fit_gmdh(t);
  ans = mean_sqr_error(t);
  return(ans);


}
