#include <malloc.h>
#include <stdlib.h>
#include <stdio.h>

#include "gpc.h"
#include "gmdh.h"
#include "proto.h"
#include "clindef.h"
#include "magic.h"
#include "problem.h"
#include "getparams.h"
#include "output.h"


pop_struct	*POP;
int		X_FLAG;
pop_struct	***GRID;
int		START_GEN;
FILE		*CKPT_FILE;
function_table_entry node_functions[MAX_NODE_FUNS];
int no_node_functions;
tree *mytree;
struct nonterminal_node  *node_list;

int 	gaussian_noise_toggle;
float 	gaussian_noise_uniform1, gaussian_noise_uniform2;
float	gaussian_noise_temp;


problem P;
parameters Param;
output Result;

double **FAST_X_ARRAY;

int ncross_at_funct_pt;
int ncross_at_any_pt;
int nmut;

int init_globals()
{

  FAST_X_ARRAY = allocdmat(P.data_train_max,FAST_X_ARRAY_Y);

  ncross_at_funct_pt=0;
  ncross_at_any_pt=0;
  nmut=0;
  START_GEN=0;

  node_list = NULL;   // Not sure of what this does, it is used on creating trees


  gaussian_noise_toggle = 1;

  make_function_table(P.numpops, POP);
  make_terminal_table(P.numpops, POP);
  allocate_populations(P.numpops, POP);
  return 0;
}

void free_globals()
{


  deallocmat(FAST_X_ARRAY);
  clear_pointer();
  sweep_pointer();


  for (int i=0; i<P.numpops; i++)
  {

    free_tree(POP[i].best_of_generation);
    free_tree(POP[i].best_of_run);
    for (int j=0; j< POP[i].population_size; j++)
    {
      free_tree(POP[i].population[j]);
    }
  }
}
