#ifndef _GLOBALS_H_
#define _GLOBALS_H_

#include <stdio.h>
#include "gpc.h"
#include "problem.h"
#include "getparams.h"
#include "output.h"
#include "memwatch.h"
// Globals from GPC.h

extern pop_struct *POP;
extern int X_FLAG;
extern pop_struct ***GRID;
extern int START_GEN;
extern FILE *CKPT_FILE;
extern function_table_entry node_functions[MAX_NODE_FUNS];
extern int no_node_functions;
extern tree *mytree;
extern struct nonterminal_node  *node_list;

// Globals from random.h

extern int 	gaussian_noise_toggle;
extern float 	gaussian_noise_uniform1, gaussian_noise_uniform2;
extern float	gaussian_noise_temp;


// Dataset and global parameters
extern problem P;

// temporary parameter holding place:
extern parameters Param;

// temporary output holding place;
extern output Result;

// used for matrix multiplications (I think)
extern double **FAST_X_ARRAY;

// these globals are used for counting
// number of crossovers and mutations, access them at will
extern int		ncross_at_funct_pt;
extern int		ncross_at_any_pt;
extern int		nmut;


// Initiates the program's global variables
// Returns -1 on failure
int init_globals();

// Free memory used by global variables
void free_globals();

#endif
