#ifndef _output_h_
#define _output_h_



// Output class is a wrapper that grabs information from
// the pop structure and cleanses it so it can be used by
// the GUI as the output of the proccess.
class output{
 public:

  // fitness of the population
  double best_mse[POPMAX];
  double avg_mse[POPMAX];
  int best_ind_mse[POPMAX]; ///< individual's index
  
  double best_mdl[POPMAX];
  double avg_mdl[POPMAX];
  int best_ind_mdl[POPMAX]; ///< individual's index
  
  // data from one individual
  // before accessing this data, run one of the functions below.
  
  int pop_number; ///< number of the population of this individual
  int ind_number; ///< number of the index of this individual
  double mse;
  double mdl;
  double output2[F_MAX]; ///< predicted output for this individual
  char tree[TREE_OUTPUT_SIZE]; ///< string description of this individual's structure
  
  /* METHODS */
  
  output(); ///< constructor. Do nothing?
  void update_populations(); ///< Update the mdl/mse values for populations
  
  void set_value(int pop, int index); ///< set the mse,mdl,tree values for individual "index" of population "pop"
  void set_pred(int pop, int index); ///< set prediction values for  individual "index" of population "pop"
  void set_pred2(int pop, int index); ///< set prediction values for  individual "index" of population "pop"
  void set_best_value(int pop); ///< set the mse,mdl,tree values for individual "index" of population "pop"
  void set_best_pred(int pop); ///< set prediction values for  individual "index" of population "pop"
  void set_best_pred2(int pop); ///< set prediction values for  individual "index" of population "pop"

  double hit_rate();

};

#endif
