#ifndef _PROBLEM_H_
#define _PROBLEM_H_


#define DEMES (P.demes)
#define DEMEROWS (P.demerows)
#define DEMECOLS (P.demecols)
#define CHECKPOINT_FREQUENCY P.chkpt_freq

#define WEIGHT P.weight
#define WEIGHT_ERROR P.weight_error


class problem
{
public:

   /* PROBLEM DATA */

   double data[F_MAX];      // data to be used by calculations
   double data_orig[F_MAX]; // non-normalized data
   double runtime; //  time taken for calculations

   /* GLOBAL PARAMETERS */

   int numpops; // Number of populations
   int numgens; // Number of generations

   int data_max;        // total number of data values
   int data_train_max;  // number of train set values
   int data_gap; // Number of individuals from the test data file which should be used as basis for prediction. Thid better be > number of terminals
   
   double data_train_variance; // Variance for the train data


   int test_and_train_same; // Bool, indicates if test set and train set are the same.
   int time_lag;    //Indicates the time lag between the current data and the terminal index 1. For normal cases, can be 0

   int eval_by_mdl; //1- eval by mdl, 0- eval by mse

   int chkpt_freq;

   double weight; // MDL WEIGHT
   double weight_error; // MDL ERROR WEIGHT (see paper)
   double reg_param; // Regularization Parameter

   double overlimit; // Limit for overflow in calculations

   // No idea on what this does. Is set to 0 in N.S. Tests.
   int demes;
   int demerows;
   int demecols;


   /* METHODS */

   // constructor, data_max=0 is a signal that the data ins not
   // initialized
   problem();

   // Data input functions
   void inputTestData(double *newdata, int array_size);
   void inputTrainData(double *newdata, int array_size);
   void inputTestDataFromFile(char *filename);
   void inputTrainDataFromFile(char *filename);

   // normalize data held in the instance
   void normalize();

   // Generates variance for training data
   double getTrainVar();

   // Gets the terminal value of termindex, relative to current
   // returns 0 if it is invalid.
   double getTerminal(int current, int termindex);
};

// Fix This
#define LEARN_FILE_NAME "Learning_Data.dat"
#define LEARN_FILE_SIZE 268
#define TEST_FILE_NAME "Exam_Data.dat"
#define TEST_FILE_SIZE 268



//#define START_INDEX 0  //default 400
//#define IGET(x) (x+START_INDEX)
//#define MDL_version 1 /* MDL fitness if 1, MSE fitness if 0 */



#endif
